# NOTE: Derived from ./blib/lib/Text/EP3.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Text::EP3;

#line 1038 "./blib/lib/Text/EP3.pm (autosplit into ./blib/lib/auto/Text/EP3/define.al)"
sub define
# Replace tokenized keys with the strings that follow 
# usage: @define key value
# (unless called by replace)
{
    my $self = shift;
    my(@input_string) = @_;
    my(@string);
    my($inline, $directive, $key);
 
    $inline = $input_string[0];
    @string = split(' ',$inline);
    print "$self->{Line_Comment}EP3->define: Entered define.  Line $Text::EP3::line of $Text::EP3::filename  The key is $string[1]\n"	if $self->{Debug} & 1;
 
    # parse key string
    $directive = shift @string;
    $key = shift @string;
 
    # make sure there is a key
    if ($key eq '') {
        die "No key definition in $self->{Delimeter}$directive, line $Text::EP3::line of $Text::EP3::filename";
    }
 
    # make sure we haven't seen this key
    if (defined $self->{Keyline}{$key}) {
        #carp "Key $key at line $Text::EP3::line in $Text::EP3::filename was previously defined at line $self->{Keyline}{$key} in file $self->{Keyfile}{$key}:";
        print "$self->{Line_Comment}EP3->define: Key $key at line $Text::EP3::line in $Text::EP3::filename was previously defined at line $self->{Keyline}{$key} in file $self->{Keyfile}{$key}:" if $self->{Debug} & 4;
    }
 
    # If there is no replacement string (i.e. just a define) make the
    # replacement string a null
    if ($#string < 0) {
        #$inline = $key . "\n";
        $inline = "\n";
    }
 
    $inline =~ s/^$directive[\s]*$key\s//;
    chomp ($inline);
    @string = ($directive,$key,$inline);
 
    # mark the self->{Keyline} with the current line number. This marks it as used, 
    # and also gives us a little info as to where.
    $self->{Keyline}{$key} = $Text::EP3::line;
    $self->{Keyfile}{$key} = $Text::EP3::filename;
 
    # place it in the key list and bump the keycount
    $self->{Keylist}[$self->{Keycount}] = $key;
    $self->{Keycount}++;
    # save the keycount in the self->{Keyfind} array to make undefines easy
    $self->{Keyfind}{$key} = $self->{Keycount};
 
    # add the stuff to replace the key with to the self->{Define_List}

    if ($directive =~ /^\s*$self->{DPAT}define/) {
        $self->{Define_List}{$key} = $inline;
        print "$self->{Line_Comment}EP3->define: Key = $key, defined as ->$self->{Define_List}{$key}<-\n" if $self->{Debug} & 4;
    }
    elsif ($directive =~ /^\s*$self->{DPAT}replace/) {
        $self->{Replace_List}{$key} = $inline;
        print "$self->{Line_Comment}EP3->define: Key = $key, replace with ->$self->{Replace_List}{$key}<-\n" if $self->{Debug} & 4;
    }
}

# end of Text::EP3::define
1;
