# NOTE: Derived from ./blib/lib/Text/EP3.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Text::EP3;

#line 1458 "./blib/lib/Text/EP3.pm (autosplit into ./blib/lib/auto/Text/EP3/if.al)"
sub if
# Read to endif if the expr evaluates true. Otherwise, ignore to endif
# The basic if, except that any perl expression can be evaluated
# usage: @if expr
{
    my $self = shift;
    my(@input_string) = @_;
    my(@string);
    my($inline, $directive, $expr, $skip, $ifkeynum, $result, $initifdef);
 
    print "$self->{Line_Comment}EP3->if: Entered if.  Line $Text::EP3::line of $Text::EP3::filename\n"		if $self->{Debug} & 1;
    $inline = $input_string[0];
    @string = split(' ',$inline);
 
    # parse key string
    $directive = shift @string;
    $expr =  join(' ',@string);	# Put together the rest of it
 
    # Bumb up the ifdef count if this is a new ifdef
    if ($directive !~ /^\s*$self->{DPAT}el[s]*if/) {
        $self->{Ifdef}++;
    } 
    # see if the expression evaluates
    no strict;
    $result = eval($expr);
    die "Error in the if clause at line $Text::EP3::line of $Text::EP3::filename -> $@" if $@;
    print "$self->{Line_Comment}EP3->if: $expr evaluates to $result\n" if
    $self->{Debug} & 16;
    if (! $result) {
        $skip = 1;
    }
    use strict;

    # If skip, continue until endif
    if ($skip) {
        # Set initifdef = to the current count for nesting checks
        $initifdef = $self->{Ifdef};
        while (<$Text::EP3::filehandle>) {
	    $Text::EP3::line = $.;
            if (/^\s*$self->{DPAT}if/) {
                # Inside of loops, keep an index for the ifdef
                $self->{Ifdef} ++;
                print "$self->{Line_Comment}EP3->if: Upping ifdef level = $self->{Ifdef}\n" if $self->{Debug} & 16;
            }
   
            if (/^\s*$self->{DPAT}else/) {
                # If this is in a nested loop, pass it by
                print "$self->{Line_Comment}EP3->if: Got an else: Ifdef = $self->{Ifdef}\n" if $self->{Debug} & 16;
                next if $initifdef < $self->{Ifdef};
                #break out of while loop
                last;
            }
            if (/^\s*$self->{DPAT}el[s]*if/) {
                # If this is in a nested loop, pass it by
                print "$self->{Line_Comment}EP3->if: Got an el[s]if: Ifdef = $self->{Ifdef}\n" if $self->{Debug} & 16;
                next if $initifdef < $self->{Ifdef};
                #break out of while loop
                # We must first parse this line for substitutions
	        $self->_ep3_do_subs();
                $self->if($_);
                last;
            }
            if (/^\s*$self->{DPAT}endif/) {
                $self->{Ifdef}--;
                print "$self->{Line_Comment}EP3->if: Got an endif: Ifdef = $self->{Ifdef}\n" if $self->{Debug} & 16;
                print "$self->{Line_Comment}EP3->if:               level = $initifdef\n" if $self->{Debug} & 16;
                # If this is still in a nested loop, pass it by
                next if $initifdef <= $self->{Ifdef};
                #break out of while loop
                last;
            }
        }
    }
}

# end of Text::EP3::if
1;
