# NOTE: Derived from ./blib/lib/Text/EP3.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Text::EP3;

#line 1101 "./blib/lib/Text/EP3.pm (autosplit into ./blib/lib/auto/Text/EP3/macro.al)"
sub macro
# Perform macro substitution
# usage: @macro key(a,b) f(a,b)
{
    my $self = shift;
    my(@input_string) = @_;
    my(@string);
    my($inline, $directive, $key);
    my($macro_name, $macro_vars, $newline);
 
    $inline = $input_string[0];
    @string = split(' ',$inline);
    print "$self->{Line_Comment}EP3->macro: Entered macro.  Line $Text::EP3::line of $Text::EP3::filename  $string[0] $string[1]\n"	if $self->{Debug} & 1;
 
    # parse key string
    $directive = shift @string;
    $key = shift @string;
 
    # make sure there is a key
    if ($key eq '') {
        die "No key definition in $self->{Delimeter}$directive, line
	$Text::EP3::line of $Text::EP3::filename";
    }
 
    $inline =~ s/^$directive[\s]+\Q$key\E\s//;
 
    chomp ($inline);
    @string = ($directive,$key,$inline);
 
    if ($key =~ /(\w+)\((.*)\)/) {
        $macro_name = $1;
        $macro_vars = $2;
        if ($macro_vars !~ /^[\w+,]*\w+$/) {
	    die "Bad macro variable $macro_vars";
        }
    }
    else {
        # This really isn't a macro now is it ....
        # So lets just make it a define ...  maybe with a carp ...
        carp "The macro definition at line $Text::EP3::line of $Text::EP3::filename contains no variables ... doing $self->{Delimeter}define instead:";
        $newline = $input_string[0];
        $newline =~ s/^(\s*$self->{DPAT})macro/$1define/;
        return( $self->define($newline));
    }
 
 
    # mark the self->{Keyline} with the current line number. This marks it as used, 
    # and also gives us a little info as to where.
    $self->{Keyline}{$macro_name} = $Text::EP3::line;
    $self->{Keyfile}{$macro_name} = $Text::EP3::filename;
 
    # place it in the key list and bump the keycount
    $self->{Keylist}[$self->{Keycount}] = $macro_name;
    $self->{Keycount}++;
    # save the keycount in the self->{Keyfind} array to make undefines easy
    $self->{Keyfind}{$macro_name} = $self->{Keycount};
 
    $self->{Macro_Value}{$macro_name} = $inline;
    $self->{Macro_Vars}{$macro_name} = $macro_vars;
    print "$self->{Line_Comment}EP3->macro: Macro = $macro_name, defined as ->$self->{Macro_Value}{$macro_name}<-\n" if $self->{Debug} & 4;
    print "$self->{Line_Comment}EP3->macro:    with variables $self->{Macro_Vars}{$macro_name}\n" if $self->{Debug} & 255;
}

# end of Text::EP3::macro
1;
