# NOTE: Derived from ./blib/lib/Text/EP3.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Text::EP3;

#line 1604 "./blib/lib/Text/EP3.pm (autosplit into ./blib/lib/auto/Text/EP3/perl_begin.al)"
sub perl_begin
# Read to perl_end and then evaluate the lines read
# usage: @perl_begin
# lines can be interpolated and then printed by using the output directives,
# @> and @>>  @<<.  Lines preceded with @> will be interpolated and printed. 
# Lines in betwee @>> and @<< will be interpolated and printed.
# subroutines can be declared as methods and then called by EP3 as directives.
{
    my $self = shift;
    my(@input_string) = @_;
    my(@string);
    my($inline, $directive, $expr, $skip, $ifkeynum);
    my($method_name);
    my(@subroutines) = ();
  
    print "$self->{Line_Comment}EP3->eval: Entered perl_begin.  Line $Text::EP3::line of $Text::EP3::filename\n"		if $self->{Debug} & 1;
    # print "In perl_begin...\n";
    $inline = $input_string[0];
    @string = split(' ',$inline);
    $self->{In_Perl_Begin}++;
    while (<$Text::EP3::filehandle>) {
	$Text::EP3::line = $.;
	# Treat directives with \ at the end as one line.
        while (/^\s*[$self->{DPAT}][\w>]+.*\\\s*\n/) {
            print "Got a splitter\n" if $self->{Debug} & 32;
            s/\\\s*\n$//;
            $_ .= <$Text::EP3::filehandle>;
	    $Text::EP3::line = $.;
        }
        if ( ! /^\s*$self->{DPAT}perl_end/ ){
            print "$self->{Line_Comment}EP3->eval: Processing ->$_" if $self->{Debug} & 32;
	    $self->_ep3_do_subs();
            #print "$self->{Line_Comment}EP3->eval: Now ->$_" if $self->{Debug} & 32;
            # Change $self->{Delimeter}> and $self->{Delimeter}>> references to be code includers
	    # i.e. call _ep3_output_code on the affected lines
	    # $self->{Delimeter}> is a single line,
	    # $self->{Delimeter}>> is a multi-line closed by $self->{Delimeter}<<
            s/^(\s*)$self->{DPAT}>>/\$self->_ep3_output_code (qq($1   /;
            s/$self->{DPAT}<<\s*$/));\n/;
            s/^(\s*)$self->{DPAT}>(.*)/\$self->_ep3_output_code (qq($1  $2));/;
	    # Now change any other directives into funtion calls
	    if (/^\s*sub\s+(\w+)/) {
	        # add any subroutines being declared to a list
	        push (@subroutines, $1);
                print "$self->{Line_Comment}EP3->eval: Adding $1 to the subroutine list.\n" if $self->{Debug} & 32;
	    }
	    if (/^\s*$self->{DPAT}(\w+)/ ) {
                print "$self->{Line_Comment}EP3->eval: It's a Directive instance!\n" if $self->{Debug} & 32;
	        # if a line beginning with @... is found, check to see
		# if it is a method that has already been defined,
		# or a subroutine being defined. If it is, assume it
		# to be a directive statement. (This avoids confusion
		# with perl constructs (arrays if the delimeter is an '@')
		$method_name = $1;
                if ( ($self->can($method_name)) || (grep /^$method_name$/,@subroutines)) {
		    ##############################################
		    # Deal with directives inside the perl script
		    ##############################################
		    # Set it up so that it does interpolate
		    # This makes directive behavior different within
		    # The PERL construct as it is without, but gives
		    # the added benefit of being able to interpolate 
		    # on directive keys as well as definitions, which
		    # is likely why we are in the PERL construct to
		    # begin with.
                    # Change the directive to a method invocation for
		    # perl evaluation
	            s/^(\s*)$self->{DPAT}(\w+)\s+(.*)/$1\$self->$2("\$self->{Delimeter}$2 $3\n");/ ;
                    print "$self->{Line_Comment}EP3->eval: Directive line is now ->$_" if $self->{Debug} & 32;
	        }
	    }
            push(@{$self->{Perl_Lines}}, $_);
	}
	else {
	    $self->perl_end($_);
	    last;		# Done!
	}
    }
}

# end of Text::EP3::perl_begin
1;
